services:
  - docker:dind

variables:
  DOCKER_DRIVER: overlay
  SPRING_PROFILES_ACTIVE: gitlab-ci
  LOAD_BALANCER_DNS: "nginx.eks.barclays.io"
  INGRESS_DNS: "account.io"

stages:
  - build
  - release
  - deploy

maven-build:
  image: maven:3-jdk-11
  stage: build 
  only:
    - master
  script: "mvn clean install"
  allow_failure: false
  artifacts:
    paths:
      - target/*.jar

docker-build:
  stage: release
  only:
    - master
  image: docker:1.11
  services:
    - docker:dind
  script:
    - export REPO=leonelcs/account
    - export VERSION=${CI_COMMIT_SHA:0:8}
    - docker login --username $DOCKER_HUB_USERNAME --password $DOCKER_HUB_PASSWORD
    - docker build --quiet --file ./Dockerfile --tag $REPO:$VERSION .
    - docker push $REPO

kubernetes:
  stage: deploy
  only:
    - master
  image:
    name: dtzar/helm-kubectl:2.12.3
    entrypoint:  ["/bin/sh", "-c"]
  before_script:
    - echo $KUBECONFIG_FILE | base64 -d >> ~/kubeconfig
    - export KUBECONFIG=~/kubeconfig
    - wget -O /usr/local/bin/aws-iam-authenticator https://amazon-eks.s3-us-west-2.amazonaws.com/1.10.3/2018-07-26/bin/linux/amd64/aws-iam-authenticator
    - chmod +x /usr/local/bin/aws-iam-authenticator
  script:
    - export VERSION=${CI_COMMIT_SHA:0:8}
    - sed -i -e "s/VERSION/${VERSION}/g" ./k8s/deployment.yaml
    - sed -i -e "s/LOAD_BALANCER_DNS/${LOAD_BALANCER_DNS}/g" ./k8s/ingress.yaml
    - sed -i -e "s/INGRESS_DNS/${INGRESS_DNS}/g" ./k8s/ingress.yaml
    - kubectl apply -f ./k8s